//Copyright 2013 Michael Leitner, distributed as free softtware,
//see COPYING for more details

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "litdb.h"

//testet ob short int in sortiertem array vorkommt (nach memchr modelliert)

int memshint(const short int * s,short int c,int n) {
	int k;
	
	for (k=0;k<n;k++) if (s[k]>=c) break;
	if ((k==n)||(s[k]>c)) return 0;
	else return 1;
}

//fügt string bei ind in liste ein

void insert_in_dump(int * Np,int ** idxp,char ** dumpp,int ind,char * insert_string) {
	int len,k;	
	char * dump=*dumpp;
	int * idx=*idxp;
	
	idx=realloc(idx,sizeof(int)*(++(*Np)+1));
	len=strlen(insert_string)+1;
	for (k=*Np;k>ind;k--) idx[k]=idx[k-1]+len;
	dump=realloc(dump,idx[*Np]);
	memmove(dump+idx[ind+1],dump+idx[ind],idx[*Np]-idx[ind+1]);
	memcpy(dump+idx[ind],insert_string,len);
	
	*idxp=idx;
	*dumpp=dump;
}

//fügt zur unit ind1 tag ind2 dazu

void insert_entry(struct database * dbp,int ind1,int ind2) {
	int k;
	struct database db=*dbp;
	
	for (k=ind2+1;k<db.Ntag+1;k++) db.colhead[k]++;
	db.tidx=realloc(db.tidx,sizeof(short int)*db.colhead[db.Ntag]);
	
	for (k=0;((db.tidx[db.colhead[ind2]+k]<ind1)&&(k<db.colhead[ind2+1]-1-db.colhead[ind2]));k++);
	memmove(db.tidx+db.colhead[ind2]+k+1,db.tidx+db.colhead[ind2]+k,(db.colhead[db.Ntag]-db.colhead[ind2]-k-1)*sizeof(short int));
	
	db.tidx[db.colhead[ind2]+k]=ind1;
	
	*dbp=db;
}

//fügt eine unit mit beliebig vielen tags oder ein tag mit beliebig vielen units dazu, mit testen
//einige verbesserungsmöglichkeiten, aber alle unwesentlich (z.b. wenn units oder tags sortiert dazugefügt werden)

int main(int argc,char *argv[]) {
	struct database db;
	int i,k,uind,tind,v;
	
	read_db(&db);
	
	if ((argc>2)&&(strcmp(argv[1],"-u")==0)) {
		uind=find_string(argv[2],db.Nunit,db.units,db.unitdump,&v);
		if (v==0) {   //unit nicht gefunden, bei ind einzufügen
			insert_in_dump(&(db.Nunit),&(db.units),&(db.unitdump),uind,argv[2]);
			//tidx anpassen
			for (i=0;i<db.colhead[db.Ntag];i++) if (db.tidx[i]>=uind) db.tidx[i]++;
		}
	
		for (i=3;i<argc;i++) {
			tind=find_string(argv[i],db.Ntag,db.tags,db.tagdump,&v);
			if (v==0) {   //tag nicht gefunden, bei ind einzufügen
				insert_in_dump(&(db.Ntag),&(db.tags),&(db.tagdump),tind,argv[i]);
				//colheads anpassen
				db.colhead=realloc(db.colhead,sizeof(int)*(db.Ntag+1));
				memmove(db.colhead+tind+1,db.colhead+tind,(db.Ntag-tind)*sizeof(int));
			} else if (memshint(db.tidx+db.colhead[tind],uind,db.colhead[tind+1]-db.colhead[tind])) continue;
			insert_entry(&db,uind,tind);   //tag zu unit
		}
	} else if ((argc>2)&&(strcmp(argv[1],"-t")==0)) {
		tind=find_string(argv[2],db.Ntag,db.tags,db.tagdump,&v);
		if (v==0) {   //tag nicht gefunden, bei ind einzufügen
			insert_in_dump(&(db.Ntag),&(db.tags),&(db.tagdump),tind,argv[2]);
			//colheads anpassen
			db.colhead=realloc(db.colhead,sizeof(int)*(db.Ntag+1));
			memmove(db.colhead+tind+1,db.colhead+tind,(db.Ntag-tind)*sizeof(int));
		}
	
		for (i=3;i<argc;i++) {
			uind=find_string(argv[i],db.Nunit,db.units,db.unitdump,&v);
			if (v==0) {   //unit nicht gefunden, bei ind einzufügen
				insert_in_dump(&(db.Nunit),&(db.units),&(db.unitdump),uind,argv[i]);
				//tidx anpassen
				for (k=0;k<db.colhead[db.Ntag];k++) if (db.tidx[k]>=uind) db.tidx[k]++; 
			} else if (memshint(db.tidx+db.colhead[tind],uind,db.colhead[tind+1]-db.colhead[tind])) continue;
			insert_entry(&db,uind,tind);   //tag zu unit
		}
	} else printf("Usage: add_db -u UNIT [TAG0 [TAG1...]]\n  or:  add_db -t TAG [UNIT0 [UNIT1...]]\nAdd arbitrary number of tags to a given unit or vice versa.\n");
		
	write_db(&db);
}
